# Excercises for objects and classes
# Alexander Kosik


#########################
### Excercise 1 
#########################

class Product:
    """
    Write a class product with the following attributes and methods:

    Attributes:
    -----------
    name: product name as string e.g. "radio"
    price: price without taxes as float value e.g. 42.99
    tax: tax in percents e.g. 19

    Methods:
    -----------
    gross(): should return the gross value (price with taxes). 
    the returned value should be round to 2 decimals (use round())
    net(): should return the net value price (price without taxes)

    String Representation
    ---------------------
    Create a string representation for the class:
    product_name: price_with_taxes
    e.g. "Radio: 51.16"

    Create a developer representation for the object:
    e.g. "Product("radio", 42.99, 19)
    """
    pass # TODO


#########################
### Excercise 2 
#########################
class Basket:
    """
    This class represents a basket. It can store products and calculate the
    price of all items (gross and net)

    Implement the following methods:
    add_product(product): adds a product to the basket
    
    remove_product(product): removes the product from the basket. If the
    product is not in the basket raise a NotFound exception

    total_gross: Returns the gross value of the basket

    total_net: Returns the net value of the basket

    clear_basket: Removes all items from basket
    """
    pass # TODO



#########################
### Excercise 3 
#########################
    """ Extend the basket class:
    Add a new method:
    add_discount(discount_percentage, number_of_items)

    add_discount is called with two arguments:
    the discount_percentage (e.g. 5)
    and the number_of_items. If the basket has more or equal number of items
    stored than the passed number_of_items, than the discount is granted.

    E.g. add_discount(10, 3) is called
    number of items in basket: 1 -> no discount
    number of items in basket: 2 -> no discount
    number of items in basket: 3 -> 10 percent discount on the basket
    """

